Class env
	#DllDeclare crtdll(_dup As myDup, _dup2 As myDup2, _fileno As myFileNo, fopen As myFopen, fflush As myFflush)
	#DllDeclare kernel32(GetStdHandle, WriteConsole)
	'http://msdn2.microsoft.com/en-us/library/8syseb29.aspx 
	'
	Private
	Shared  %d_stdIn = 0, %d_dupStdIn, %d_newStdIn = 0, %d_stdOut = 0, %d_dupStdOut, %d_newStdOut = 0
	Shared  %d_errHandle = 0
	'
	Function redirect_($p_fileName, $p_mode, %p_old, %p_dup, %p_new)
		Const FAIL = -1
		Const NONE = 0
		Dim %d_tmp, d_handle
		If p_mode = "r" Then
			d_handle = STDIN
		Else
			d_handle = STDOUT
		End If
		If p_old = 0 Then 'get file descriptor and its duplicate  
			p_old = myFileNo(d_handle)
			p_dup = myDup(p_old)
		End If
		If p_fileName = "" Then ' restore old 
			If p_new <> 0 Then
				myFflush(d_handle)
				If myDup2(p_dup, p_old) = -1 Then
					Return(FALSE)
				End If
				p_new = 0
			End If
		Else
			 %d_tmp = myFopen(p_fileName, p_mode) ' open new file 
			If d_tmp = NONE Then Return(FALSE) 'failed to open file 
			 %d_tmp = myFileno(d_tmp) ' get file descriptor from file pointer 
			If  %d_tmp = FAIL Then ' 'failed to get file descriptor 
				Return(FALSE)
			Else
				If myDup2(d_tmp, p_old) = FAIL Then Return(FALSE) 'failure 
				p_new = d_tmp
			End If
		End If
		Return(TRUE)
	End Function
	
	Method Initialize(%flags = 0, _
		%fAllow = FILE_ATTRIBUTE_ARCHIVE + FILE_ATTRIBUTE_READONLY, _
		%dAllow = FILE_ATTRIBUTE_DIRECTORY + FILE_ATTRIBUTE_READONLY)
		Dim %f_stdio = flags BAnd C_STDIO
		Dim %f_files = flags BAnd C_FILES
		Dim %f_esc = flags BAnd C_ESC
		Dim %f_opt = flags BAnd C_OPT
		Dim %i, $v, %ok, $fin = "", $fout = "", $mode = ""
		argv[] = Command(1 - STANDALONE)
		For i = 2 - STANDALONE To CommandCount() - 1
			ok = TRUE
			v = Command(i)
			If f_esc Then
				If v{1} = "/" Then
					ok = FALSE
					f_opt = FALSE
					argv[] = Mid(v, 2)
				End If
			End If
			If ok Then
				If f_opt Then
					If v{1} = "-" Then
						If Mid(v, 2, 1) <> "" Then
							options = options & Mid(v, 2, 1)
							optv[] = Mid(v, 3)
						End If
						ok = FALSE
					Else
						f_opt = FALSE
					End If
				End If
			End If
			If ok Then
				If f_stdio Then
					If v{1} = ">" Then
						ok = FALSE
						If v{2} = ">" Then
							fout = Mid(v, 3)
							mode = "a"
						Else
							fout = Mid(v, 2)
							mode = "w"
						End If
					ElseIf v{1} = "<" Then
						ok = FALSE
						fin = Mid(v, 2)
					End If
				End If
			End If
			If ok Then
				If f_files Then
					If Instr(v, "*") Or Instr(v, "?") Then
						argv = Array_Merge(argv, getFiles(v, "", fAllow, dAllow))
						ok = FALSE
					End If
				End If
			End If
			If ok Then
				argv[] = v
			End If
		Next
		argc = Count(argv)
		If fin <> "" Then redirectStdIn(fin)
		If fout <> "" Then redirectStdOut(fout, mode)
	End Method
	'
	Public
	
	
	Dim options = "", optv[], argv[], %argc = 0
	Begin Const
		C_STDIO = 1 'allow redirection of STDIN,STDOUT
		C_FILES = 2 'expand parameters with * and ?
		C_ESC = 4 'parameters starting with \ are not processed(\ is trimmed off)
		C_OPT = 8 'leading parameters starting with - are processed as options
	End Const
	
	Method getFiles($fname, $dir = "", _
		%fAllow = FILE_ATTRIBUTE_ARCHIVE + FILE_ATTRIBUTE_READONLY, _
		%dAllow = FILE_ATTRIBUTE_DIRECTORY + FILE_ATTRIBUTE_READONLY)
		#DllDeclare crtdll("_findfirst" As myFFirst, "_findnext" As myFNext, "_findclose" As myFClose)
		'http://msdn2.microsoft.com/en-us/library/kda16keh.aspx
		'fname - path string with optional * and ? joker characters at any position
		'dir - optional base directory - no joker characters allowed (must end with \) 
		
		Dim arr[]
		Dim %p, %pJoker, %pRest = 0
		Dim $path = dir, $search = fname, $rest, $f
		Dim %fMask = BNot fAllow, %dMask = BNot dAllow
		Dim %fStat, %fHandle, %attr, %searchHandle, $fileInfo * MAX_PATH + 41
		'are there any joker characters?
		pJoker = Instr(search, "*")
		p = Instr(search, "?")
		If p And p < pJoker Then pJoker = p
		'
		If pJoker Then 'jokers exist in search
			p = InstrRev(search, "\", pJoker)
			If p Then
				path = dir & Left(search, p) 'set new base directory
				search = Mid(search, p + 1)
			End If
			pRest = Instr(search, "\") 'is joker for directory?
			If pRest Then 'directory with joker characters 
				rest = Mid(search, pRest + 1)
				search = Left(search, pRest - 1)
			End If
		End If
		fHandle = myFFirst(path & search, @fileInfo)
		fStat = fHandle
		While fStat <> -1
			'f =TO_LPSTR( @fileInfo+20)
			If f{1} <> "." Then
				attr = GetMem(fileInfo, 0, %4)
				If pRest Then
					If Not (attr BAnd dMask) And (attr BAnd FILE_ATTRIBUTE_DIRECTORY) Then arr = Array_Merge(arr, getFiles(rest, path & To_Lpstr(@fileInfo + 20) & "\", fAllow, dAllow))
				Else
					If Not (attr BAnd fMask) Then arr[] = path & To_Lpstr(@fileInfo + 20)
				End If
			End If
			fStat = myFnext(fHandle, @fileInfo)
		Wend
		If fHandle <> -1 Then myFClose(fHandle)
		Return arr
	End Method
	
	Method printError($p_message, p_CRLF = CRLF)
		Dim %d_len, d_buf = $p_message & p_CRLF
		If d_errHandle = 0 Then d_errHandle = GetStdHandle(STD_ERROR_HANDLE)
		WriteConsole(d_errHandle, @d_buf, StrLen(d_buf), @d_len, 0)
	End Method
	
	Method redirectStdIn($p_fileName = "")
		Return(redirect_(p_fileName, "r", d_stdIn, d_dupStdIn, d_newStdIn))
	End Method
	
	Method redirectStdOut($p_fileName = "", $p_mode = "w")
		Return(redirect_(p_fileName, p_mode, d_stdOut, d_dupStdOut, d_newStdOut))
	End Method
End Class